#pragma rtGlobals=1		// Use modern global access method.

Macro rescale_WF_LEEDIV()

	// extract the waterfall name according to SIS conventions
	String WF_nameStr = StringFromList(0,WaveList("*_WF",";","WIN:"))
	String WFP_nameStr = StringFromList(0,WaveList("*_P",";","WIN:"))
	String WFQ_nameStr = StringFromList(0,WaveList("*_Q",";","WIN:"))

	// check the availabality of the required waves
	variable abortFlag = 0
	if (strlen(WF_nameStr)==0)
		abortFlag = 1
		print "Select the waterfall window first."
	endif
	if ((abortFlag==0)&&(strlen(WFP_nameStr)==0))
		abortFlag = 1
		print "Convert the x axis units to momentum transfer."
	endif
	if ((abortFlag==0)&&(strlen(WFQ_nameStr)==0))
		abortFlag = 1
		print "Convert the y axis units to momentum transfer."
	endif

	// if everything is fine, proceed with creating a new waterfall
	if (abortFlag == 0)
		duplicate/o $WFQ_nameStr, newWFQ
		duplicate/o $WFP_nameStr, newWFP
		duplicate/o $WF_nameStr, tempWF
		duplicate/o $WF_nameStr, newWF
		calculatenewWF($WFP_nameStr,$WFQ_nameStr,newWFP, newWFQ, $WF_nameStr, newWF, tempWF)	
	endif

end

function calculateNewWF(pwaveOld, qwaveOld, pwaveNew, qwaveNew, WFold, WFnew, WFconv)
	wave pwaveOld, qwaveOld, pwaveNew, qwaveNew, WFold, WFnew, WFconv

	variable numQpts = numpnts(qwaveOld)
	variable numPpts = numpnts(pwaveOld)
	variable Qmin, Qmax, i, j
	variable Qreal
	variable Qindex
	variable dQnew
		
	WFnew = 0
	WFconv[][] = qwaveOld[q] * (0.5 + 0.5*sqrt(1-(2*pwaveOld[p]/qwaveOld[q])^2) )
	wavestats/Q tempWF
	qwaveNew[] = V_min + p*(V_max-V_min)/numQpts
	dQnew = (V_max-V_min)/numQpts
	Qmin = V_min
	Qmax = V_max
	
	duplicate/o WFnew,deleteImageWave
	deleteImageWave=0
	
	i=0
	do
		j=0
		do
			Qreal = WFconv[i][j]
			Qindex = trunc((Qreal - Qmin) / dQnew)
			WFnew[i][Qindex] += (Qreal-qwaveNew[Qindex]) * WFold[i][j] / dQnew
			WFnew[i][Qindex+1] += (qwaveNew[Qindex+1]-Qreal) * WFold[i][j] / dQnew
			deleteImageWave[i][Qindex]+=(Qreal-qwaveNew[Qindex]) / dQnew
			deleteImageWave[i][Qindex+1]+=(qwaveNew[Qindex+1]-Qreal) / dQnew
			j=j+1
		while (j<numQpts)
		i=i+1
	while(i<numPpts)
	
	i=0
	do
		j=0
		do
			if (deleteImageWave[i][j]>0.00001)
				WFnew[i][j] /= deleteImageWave[i][j]
			endif
			j=j+1
		while (j<numQpts)
		i=i+1
	while(i<numPpts)

end